SystemOrganization addCategory: #SWA014!

CircleMorph subclass: #SWA014Food
	instanceVariableNames: 'bodysize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Food commentStamp: 'Tc 1/6/2017 16:24' prior: 0!
Zur Zeit nicht verwendet aus Performancegründen!

!SWA014Food class methodsFor: 'as yet unclassified' stamp: 'Tc 12/31/2016 14:49'!
newWithSize: aSize		
	^self new
		bodysize: aSize;
		extent: aSize asPoint;
		color: Color yellow;
		yourself.
		! !

!SWA014Food methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:06'!
bodysize 
	^bodysize.! !

!SWA014Food methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:06'!
bodysize: aSize
	bodysize := aSize.! !

!SWA014Food methodsFor: 'accessing' stamp: 'MV 1/13/2017 16:30'!
isBlob
	^false.! !

!SWA014Food methodsFor: 'body transformation' stamp: 'MV 1/13/2017 16:30'!
squaredRadius
	^(self bodysize / 2) squared.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'bodysize speed speedSaver id direction world currentStep maxAllowedSize minAllowedSize minAllowedSpeed maxAllowedSpeed realCenter upgradeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Blob
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Blob commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Blob methodsFor: 'body transformation' stamp: 'MV 1/27/2017 13:03'!
checkForEvolution
	self bodysize > 100 ifTrue: [self evolve].! !

!SWA014Blob methodsFor: 'body transformation' stamp: 'MV 1/27/2017 12:12'!
evolve
	self flag: 'Anpassen für Score. Ein Counter muss hochgezählt werden'.
	self swaworld game showEvolveOptions.
	self bodysize: 50.
	self level: self level + 1.
	! !

!SWA014Blob methodsFor: 'initialization' stamp: 'MV 1/27/2017 13:01'!
initialize
	super initialize.
	self speed: 3.0.
	self level: 0.! !

!SWA014Blob methodsFor: 'constants' stamp: 'Tc 1/13/2017 14:24'!
isBlob
 	^true.! !

!SWA014Blob methodsFor: 'accessing' stamp: 'MV 1/27/2017 12:11'!
level
	^ level.! !

!SWA014Blob methodsFor: 'accessing' stamp: 'MV 1/27/2017 12:12'!
level: aNumber
	level := aNumber.! !

!SWA014Blob methodsFor: 'movement' stamp: 'MV 1/3/2017 00:34'!
moveAutomatically
	self swaworld realCenter: self swaworld realCenter - (self speed * self direction).
	self swaworld refreshCenter.
	self realCenter: self realCenter + (self speed * self direction).
	self refreshCenter.! !

!SWA014Blob methodsFor: 'movement' stamp: 'L.K. 1/13/2017 14:51'!
movementConstant
	^3.! !

!SWA014Blob methodsFor: 'override' stamp: 'MV 1/21/2017 15:30'!
step
	super step.
	
	self 
		direction: (self calculateDirection: (self calculateRealCenterFor: World activeHand center));
		moveAutomatically;
		yourself.! !

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'movement' stamp: 'MV 1/21/2017 15:30'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."
calculateDirection: target
	|direction|
	direction := super calculateDirection: target realCenter.
	^self < target
		ifTrue: [direction negated]
		ifFalse: [direction].
	! !

!SWA014Enemy methodsFor: 'override' stamp: 'MV 1/27/2017 12:30'!
step
	self 
		direction: (self calculateDirection: self nearestEnemy);
		moveAutomatically;
		yourself. 
	
	self upgradeList do: [:aUpgrade|
		aUpgrade activateIfNotCooling].
	
	super step.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 22:37'!
< aLivingThing
	^self bodysize < aLivingThing bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 22:39'!
> aLivingThing
	^self bodysize > aLivingThing bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 21:39'!
addMassOf: aLivingThing
	self bodysize: 2 * ((self squaredRadius + aLivingThing squaredRadius) sqrt).! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:39'!
bigNumber
	^SmallInteger maxVal.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 22:59'!
bodysize 
	^bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 12/16/2016 12:09'!
bodysize: x
	x < (self maxAllowedSize)
		ifTrue: [
			x > (self minAllowedSize) 
				ifTrue: [	bodysize := x]
				ifFalse: [bodysize := self minAllowedSize]]
		ifFalse: [bodysize := self maxAllowedSize].
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/27/2017 12:49'!
calculateDirection: target
	^ self vectorToPoint: target.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/13/2017 01:04'!
calculateRealCenterFor: aPosition
	self flag: 'TODISCUSS: In welche Klasse gehört diese Methode?'.
	^aPosition - self swaworld realCenter + self swaworld radius asPoint.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/13/2017 15:55'!
checkForCollisions
	self 
		checkForCollisionsWithLivingThings;
		checkForCollisionsWithFood;
		"checkForCollisionsWithFood;" "Zur Zeit ist food nicht aktiv, deswegen ist es nicht nötig auf Kollisionen zu prüfen"
		yourself.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/13/2017 00:17'!
checkForCollisionsWithFood
	self swaworld listOfFood do: [:eatable|
		(self distanceTo: (self calculateRealCenterFor: eatable center)) < self squaredRadius ifTrue: [
			self eat: eatable]].! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/12/2017 22:40'!
checkForCollisionsWithLivingThings
	self swaworld listOfLivingThings do: [:enemy|
		(self checkForOverlapWith: enemy) ifTrue: [
			enemy < self 
				ifTrue: [	enemy goBehind.
						(self distanceTo: enemy realCenter) < self squaredRadius ifTrue: [
							self eat: enemy]] 
				ifFalse: [enemy comeToFront].
			self swaworld image goBehind]] without: self.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 12/10/2016 14:04'!
checkForOverlapWith: enemy
	^(self bottom > enemy top and: 
	    self top < enemy bottom and:
	    self left < enemy right and:
	    self right > enemy left).
! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 20:53'!
currentStep
	^currentStep.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 20:52'!
currentStep: x
	currentStep := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:44'!
direction: x
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 1/12/2017 22:31'!
distanceTo: enemy
	^((enemy x - self realCenter x) squared) +
	 ((enemy y - self realCenter y) squared). "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'MV 1/13/2017 17:06'!
eat: prey
	self addMassOf: prey.

	self swaworld listOfEnemies remove: prey ifAbsent: [].
	self swaworld listOfFood remove: prey ifAbsent: [].
	
	prey isBlob not
 		ifTrue: [	prey delete.
				self swaworld game spawnEnemy.]
		ifFalse: [self swaworld game gameOver].
		
	self isBlob ifTrue: [self checkForEvolution.].! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'MV 1/27/2017 12:10'!
initialize
	super initialize.
	
	self 
		maxAllowedSize: 800;
		maxAllowedSpeed: 1000;
		minAllowedSize: 10;
		minAllowedSpeed: 0;
		currentStep: 0;
		speed: 2.0;
		speedSaver: 2.0;
		direction: 0.0 asPoint;
		borderWidth: 2; "these initial values don't change at runtime"
		upgradeList: Dictionary new;
		yourself.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 1/12/2017 19:45'!
isBlob
	^false.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSize
	^maxAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:32'!
maxAllowedSize: aNumber
	maxAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
maxAllowedSpeed
	^maxAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:12'!
maxAllowedSpeed: aNumber
	maxAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:35'!
minAllowedSize
	^minAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:33'!
minAllowedSize: aNumber
	minAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'MV 12/16/2016 15:36'!
minAllowedSpeed
	^minAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'Tc 12/4/2016 23:13'!
minAllowedSpeed: aNumber
	minAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/3/2017 00:33'!
moveAutomatically
	self realCenter: self realCenter + (self speed * self direction).
	self refreshCenter.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 1/7/2017 15:15'!
nearestEnemy
	|smallestDistance nearestEnemyobject currentDistance|
	
	smallestDistance := self bigNumber.
	nearestEnemyobject := self.
		
	self swaworld listOfLivingThings do: [:enemy| 
		currentDistance := self distanceTo: (enemy realCenter).
		currentDistance  < smallestDistance ifTrue: [
			smallestDistance := currentDistance.
			nearestEnemyobject := enemy]]
	without: self.

	^nearestEnemyobject.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 21:29'!
radius
	^self bodysize/2.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:29'!
realCenter
	^realCenter.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:30'!
realCenter: aPoint
	realCenter := aPoint.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/20/2016 16:15'!
refreshCenter
	self center: self swaworld realCenter - ((self swaworld width / 2)@(self swaworld height / 2)) + self realCenter.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 23:17'!
refreshSize
	self extent: self bodysize asPoint.
	
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/20/2017 12:13'!
saveSpeed
	self speedSaver: self speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 12/16/2016 15:48'!
speed: x
	x < self maxAllowedSpeed 
		ifTrue: [
			x> (self minAllowedSpeed) 
			ifTrue: [speed := x]
			ifFalse: [speed := self minAllowedSpeed]]
		ifFalse: [speed := self maxAllowedSpeed].
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/20/2017 12:08'!
speedSaver
	^ speedSaver.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'MV 1/20/2017 12:08'!
speedSaver: aSpeed
	speedSaver := aSpeed.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'MV 1/12/2017 22:31'!
squaredRadius
	"Der Radius wird Quadriert, damit wir, wenn wir mit ihm vergleichen, keine Wurzel ziehen müssen (Phytagoras)"
	^self radius squared. ! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 1/7/2017 14:27'!
step
	self checkForCollisions.
	
	self	refreshSize;
		"refreshCenter;"
		yourself.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'Tc 12/31/2016 15:34'!
stepNumber
	"This is used to keep the stepTime up to date"
	self flag: 'Zur Zeit nicht verwendeet und auch verhaltenstechnisch als (leicht) fehlerhaft anzusehen'.
	
	^self speed ~= 0
	   	ifTrue: [	10 * self bodysize / self speed]
		ifFalse: [SmallInteger maxVal. "Stepping very slow"].
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'MV 12/21/2016 19:03'!
stepTime
	^1.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'M.V. 11/18/2016 13:12'!
swaworld
	^world.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:55'!
swaworld: aWorld
	world := aWorld.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:38'!
upgradeList
	^upgradeList.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:37'!
upgradeList: aList
	upgradeList := aList.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'MV 1/27/2017 12:48'!
vectorToPoint: aPoint
	|vector|
	vector := aPoint - self realCenter.
	^ vector normalized.! !

CircleMorph subclass: #SWA014Trap
	instanceVariableNames: 'swaworld scalingFactor preySpeed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Trap methodsFor: 'collision handling' stamp: 'MV 1/13/2017 00:55'!
checkForCollisionsWithLivingThings
	self swaworld listOfLivingThings do: [:aLivingThing|
		(aLivingThing distanceTo: (aLivingThing calculateRealCenterFor: self center)) < aLivingThing squaredRadius ifTrue: [
			self collideWith: aLivingThing]].! !

!SWA014Trap methodsFor: 'collision handling' stamp: 'MV 1/13/2017 01:37'!
collideWith: aLivingThing
	self inflictAilmentTo: aLivingThing.
	self futureDo: #removeAilmentOf: at: 5000 args: (Array with: aLivingThing).
	self delete.! !

!SWA014Trap methodsFor: 'ailments' stamp: 'MV 1/13/2017 00:48'!
inflictAilmentTo: aLivingThing
	aLivingThing bodysize: aLivingThing bodysize / self scalingFactor.
	self preySpeed: aLivingThing speed.
	aLivingThing speed: 0.! !

!SWA014Trap methodsFor: 'initialization' stamp: 'MV 1/13/2017 00:49'!
initialize
	super initialize.
	self 
		color: Color blue;
		extent: 15 asPoint;
		scalingFactor: 1.5;
		yourself.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/13/2017 00:47'!
preySpeed
	^ preySpeed.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/13/2017 00:48'!
preySpeed: aSpeed
	preySpeed := aSpeed.! !

!SWA014Trap methodsFor: 'ailments' stamp: 'MV 1/13/2017 00:49'!
removeAilmentOf: aLivingThing
	aLivingThing speed: self preySpeed.
	aLivingThing bodysize: aLivingThing bodysize * self scalingFactor.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/13/2017 00:43'!
scalingFactor
	^ scalingFactor.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/13/2017 00:43'!
scalingFactor: aFactor
	scalingFactor := aFactor.! !

!SWA014Trap methodsFor: 'override' stamp: 'MV 1/13/2017 01:09'!
step
	self checkForCollisionsWithLivingThings.! !

!SWA014Trap methodsFor: 'override' stamp: 'MV 1/13/2017 01:10'!
stepTime
	^100.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/7/2017 14:58'!
swaworld
	^ swaworld.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'MV 1/7/2017 14:58'!
swaworld: anWorld
	swaworld := anWorld.! !

Morph subclass: #SWA014EvolveOption
	instanceVariableNames: 'upgrade game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EvolveOption class methodsFor: 'initialization' stamp: 'MV 1/20/2017 14:47'!
newWithUpgrade: anUpgrade
	^ self new
		initializeWith: anUpgrade;
		yourself.! !

!SWA014EvolveOption methodsFor: 'initialization' stamp: 'Tc 1/26/2017 18:16'!
createChooseButton
	| chooseButton |
	
	chooseButton := SWA014ChooseButton new.
	chooseButton center: (self center x)@(self height * 3 / 4).
	self addMorph: chooseButton.! !

!SWA014EvolveOption methodsFor: 'initialization' stamp: 'Tc 1/26/2017 18:25'!
createStringMorphForOption
	| stringMorph |

	stringMorph := StringMorph new.
	stringMorph acceptValue: self upgrade.	
	stringMorph center: (self center x)@(self height * 1 / 4).
	self addMorph: stringMorph .! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'MV 1/13/2017 14:48'!
game
	^ game.! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'MV 1/13/2017 14:49'!
game: aGame
	game := aGame.! !

!SWA014EvolveOption methodsFor: 'upgrade managment' stamp: 'MV 1/24/2017 13:04'!
getChosen
	self game enable: self upgrade for: self game swaworld blob.
	self owner delete.
	self game continue.
	self game upgradesNewToBlob remove: self upgrade ifAbsent: [].! !

!SWA014EvolveOption methodsFor: 'initialization' stamp: 'Tc 1/26/2017 18:25'!
initializeWith: upgrade
	
	self 
		extent: (150@250);
		color: Color white;
		upgrade: upgrade;
		yourself.

	self createChooseButton.
	self createStringMorphForOption.
	
	
	
	! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'MV 1/13/2017 13:58'!
upgrade
	^ upgrade.! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'MV 1/13/2017 13:59'!
upgrade: anUpgrade
	upgrade := anUpgrade.! !

Morph subclass: #SWA014Game
	instanceVariableNames: 'upgradeDictionary upgradesNewToBlob isPaused world maxSize numberOfEnemies foodSize amountOfFood upgradeBar'
	classVariableNames: 'Highscore'
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'MV 1/20/2017 15:20'!
highscore
	^ Highscore! !

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'MV 1/20/2017 15:20'!
highscore: aHighscore
	Highscore := aHighscore! !

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'Tc 1/27/2017 10:16'!
open
	self flag: 'TODO: Here is some code commented out: Decide what to do with it later'.
	^self new spawnPlayerBlob; openHighscoreWindow; "spawnEnemy;" "spawnFood;" openInWorld; spawnUpgradeBar; yourself.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
amountOfFood
	^amountOfFood.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
amountOfFood: anAmount
	amountOfFood := anAmount.! !

!SWA014Game methodsFor: 'game events' stamp: 'MV 1/20/2017 16:28'!
continue
	self swaworld listOfLivingThings do: [:aLivingThing|
		aLivingThing speed: (aLivingThing speedSaver)].
	self isPaused: false.! !

!SWA014Game methodsFor: 'upgrade managment' stamp: 'MV 1/21/2017 14:00'!
enable: upgrade for: aLivingThing
	|anUpgrade anAssociation|
	anUpgrade := (self upgradeDictionary at: upgrade ifAbsent: [SWA014NullUpgrade]) new.
	anUpgrade upgradeOwner: aLivingThing.
	aLivingThing isBlob 
		ifTrue: [self upgradeBar add: anUpgrade]
		ifFalse: [self addMorph: anUpgrade.
				anUpgrade hide].
	anAssociation := Association new key: upgrade value: anUpgrade.
	aLivingThing upgradeList add: anAssociation.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:55'!
foodSize
	^foodSize.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:55'!
foodSize: aSize
	foodSize := aSize.! !

!SWA014Game methodsFor: 'game events' stamp: 'MV 12/16/2016 11:35'!
gameOver
	self delete.! !

!SWA014Game methodsFor: 'event handling' stamp: 'MV 1/21/2017 15:59'!
handleKeystroke: anEvent
	|keyValue|
	keyValue := anEvent keyValue.
	
	keyValue = 49 ifTrue: [ "Taste: 1"
		(self swaworld blob upgradeList at: #Trap ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 50 ifTrue: [ "Taste: 2"
		(self swaworld blob upgradeList at: #Speedboost ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 51 ifTrue: [ "Taste: 3"
		(self swaworld blob upgradeList at: #Shockwave ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 52 ifTrue: [ "Taste: 4"
		(self swaworld blob upgradeList at: #Drain ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 120 ifTrue: [ "Taste: x"
		self delete].	
	keyValue = 112 ifTrue: [ "Taste: p"
		self isPaused 
			ifTrue: [self continue]
			ifFalse: [self pause]].	
	
	Transcript show: keyValue.! !

!SWA014Game methodsFor: 'event handling' stamp: 'MV 1/3/2017 01:49'!
handlesMouseOver: anEvent
	^true.! !

!SWA014Game methodsFor: 'initialization' stamp: 'MV 1/27/2017 11:40'!
initialize
	super initialize.

	self 
		extent: ActiveWorld extent;
		clipSubmorphs: true;
		swaworld: SWA014World new;
		addMorph: self swaworld;
		maxSize: 75;
		foodSize: 10;
		numberOfEnemies:50;
		amountOfFood: 1000; "initial values"
		initializeDictionary;
		initializeUpgradesNewToPlayer;
		spawnPlayerBlob;
		openHighscoreWindow;
		spawnUpgradeBar;
		openInWorld;
		isPaused: false;
		yourself.
		
	1 to: self numberOfEnemies do:[:x| self spawnEnemy ]. 
		
	self swaworld game: self.
	self swaworld center: self center.
	self swaworld realCenter: self center.
	self swaworld image center: self center.
! !

!SWA014Game methodsFor: 'initialization' stamp: 'MV 1/21/2017 15:47'!
initializeDictionary
	|aDictionary anAssociation|
	aDictionary := Dictionary new.
	
	anAssociation := Association new key: #Trap value: SWA014TrapUpgrade.
	aDictionary add: anAssociation.
	anAssociation := Association new key: #Speedboost value: SWA014SpeedboostUpgrade.
	aDictionary add: anAssociation.
	anAssociation := Association new key: #Drain value: SWA014DrainUpgrade.
	aDictionary add: anAssociation.
	anAssociation := Association new key: #Shockwave value: SWA014ShockwaveUpgrade.
	aDictionary add: anAssociation.
	
	self upgradeDictionary: aDictionary.
	! !

!SWA014Game methodsFor: 'initialization' stamp: 'MV 1/24/2017 12:10'!
initializeUpgradesNewToPlayer
	|listOfKeys|
	listOfKeys := OrderedCollection new.
	self upgradeDictionary keysDo: [:aKey| listOfKeys add: aKey].
	self upgradesNewToBlob: listOfKeys.! !

!SWA014Game methodsFor: 'accessing' stamp: 'MV 1/20/2017 16:27'!
isPaused
	^ isPaused.! !

!SWA014Game methodsFor: 'accessing' stamp: 'MV 1/20/2017 16:27'!
isPaused: aBoolean
	isPaused := aBoolean.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:02'!
maxSize
	^maxSize.
	! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 11:50'!
maxSize: aSize
	maxSize := aSize.! !

!SWA014Game methodsFor: 'event handling' stamp: 'MV 1/3/2017 01:50'!
mouseEnter: anEvent
	anEvent hand newKeyboardFocus: self.! !

!SWA014Game methodsFor: 'event handling' stamp: 'MV 1/3/2017 01:51'!
mouseLeave: anEvent
	anEvent hand newKeyboardFocus: nil.! !

!SWA014Game methodsFor: 'world manipulation' stamp: 'MV 1/13/2017 02:03'!
moveBlobToCenter
	self swaworld realCenter: self swaworld realCenter + ((self swaworld blob calculateRealCenterFor: self center) - self swaworld blob realCenter).
	self swaworld refreshCenter.! !

!SWA014Game methodsFor: 'constants' stamp: 'MV 12/16/2016 12:03'!
numberOfEnemies
	^numberOfEnemies.! !

!SWA014Game methodsFor: 'constants' stamp: 'Tc 12/4/2016 21:25'!
numberOfEnemies: aNumber
	numberOfEnemies := aNumber.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 1/13/2017 15:12'!
openHighscoreWindow
	|newHighscoreWindow|
	
	newHighscoreWindow := SWA014Highscore new. 
	newHighscoreWindow swaworld: self swaworld.
	newHighscoreWindow openInWorld.
	self addMorph: newHighscoreWindow.! !

!SWA014Game methodsFor: 'game events' stamp: 'MV 1/20/2017 16:28'!
pause
	self swaworld listOfLivingThings do: [:aLivingThing|
		aLivingThing saveSpeed.
		aLivingThing speed: 0].
	self isPaused: true.! !

!SWA014Game methodsFor: 'game events' stamp: 'MV 1/26/2017 23:41'!
showEvolveOptions
	|evolveOption holder random index upgrade shownUpgrades numberOfOptions|
	shownUpgrades := Set new.
	holder := Morph new.
	holder color: Color transparent.
	self addMorph: holder.
	random := Random new.
	numberOfOptions := self upgradesNewToBlob size.
	numberOfOptions > 3 ifTrue: [numberOfOptions := 3].
	1 to: numberOfOptions do: [:aPosition|
		index := random nextInt: self upgradesNewToBlob size.
		upgrade := self upgradesNewToBlob at: index.
		evolveOption := SWA014EvolveOption newWithUpgrade: upgrade.
		self upgradesNewToBlob removeAt: index.
		shownUpgrades add: upgrade.		 
		holder addMorph: evolveOption.
		evolveOption game: self.
		evolveOption center: (aPosition / (numberOfOptions + 1) * self width)@(self center y)].
	shownUpgrades do: [:aUpgrade|
		self upgradesNewToBlob add: aUpgrade].
	numberOfOptions > 0 ifTrue: [self pause].! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 1/27/2017 15:07'!
spawnEnemy
	|enemy random  randomNumber0 randomNumber1 randomNumber2 randomNumber3 randomNumber4 listOfKeys upgradeNumberToEnable|
	
	enemy := SWA014Enemy new.
	self maxSize: (self swaworld blob bodysize * 1.1) asInteger.
	listOfKeys := self upgradeDictionary keys asOrderedCollection.
	random := Random new.
	randomNumber0 := random nextInt: 4.
	randomNumber0 > 1 ifTrue: [self maxSize: 100].
	randomNumber1 := random nextInt: self swaworld width.
	randomNumber2 := random nextInt: self swaworld height.
	randomNumber3 := random nextInt: self maxSize.
	
	upgradeNumberToEnable := self swaworld blob level.
	listOfKeys size < upgradeNumberToEnable ifTrue: [upgradeNumberToEnable := listOfKeys size].
	1 to: upgradeNumberToEnable do: [:aNumber|
		| randomValue |
		randomNumber4 :=  random nextInt: listOfKeys size.
		randomValue := listOfKeys atRandom.
		self enable: randomValue for: enemy.
		listOfKeys remove: randomValue].
		
	enemy realCenter: randomNumber1@randomNumber2.
	enemy bodysize: randomNumber3.	
	enemy swaworld: self swaworld.
	enemy refreshCenter.
	self swaworld listOfEnemies add: enemy.
	self swaworld addMorph: enemy.! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 12/20/2016 16:17'!
spawnFood
	|eatable random r1 r2|

	self flag: 'Diese Methode ist extrem ähnlich zu spawnEnemy. Wie sollten das irgendwie zusammenfassen'.
		
	1 to: (self amountOfFood)  do: [:x|	
		eatable := SWA014Food newWithSize: self foodSize.
		random := Random new.
		r1 := random nextInt: self swaworld width.
		r2 := random nextInt: self swaworld height.
		eatable center: ((r1 + self swaworld left) @ (r2 + self swaworld top)).
		self swaworld listOfFood add: eatable.
		self swaworld addMorph: eatable].! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 1/27/2017 10:16'!
spawnPlayerBlob
	|newPlayerBlob|
	newPlayerBlob := SWA014Blob new.
	newPlayerBlob color: Color red.
	newPlayerBlob bodysize: 60.
	newPlayerBlob realCenter: (self swaworld width / 2)@(self swaworld height / 2).
	newPlayerBlob center: self center.
	newPlayerBlob swaworld: self swaworld.		
	self swaworld blob: newPlayerBlob.
	self swaworld addMorph: newPlayerBlob.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 11/11/2016 14:35'!
spawnPowerup
self flag: 'TODO: implement; this is an extension and shouldn''t be implemented until the basic game works'.! !

!SWA014Game methodsFor: 'spawning' stamp: 'MV 1/20/2017 18:59'!
spawnUpgradeBar
	|aBar|
	aBar := SWA014UpgradeBar new position: (self bounds right - 125)@(self bounds top + 50).
	self addMorph: aBar.
	self upgradeBar: aBar.
	! !

!SWA014Game methodsFor: 'override' stamp: 'MV 1/13/2017 02:06'!
step
	"|missingEnemies|"
	self moveBlobToCenter.
	"missingEnemies := self numberOfEnemies - (self swaworld listOfEnemies count: [:each| true]).
	1 to: missingEnemies do: [:x|
		self spawnEnemy]."	"Auskommentiert, da das gewünschte verhalten zur Zeit bereits in LivingThing->eat implementiert ist"! !

!SWA014Game methodsFor: 'override' stamp: 'MV 1/13/2017 02:07'!
stepTime
	^5000.! !

!SWA014Game methodsFor: 'accessing' stamp: 'M.V. 11/18/2016 13:21'!
swaworld
	^world.! !

!SWA014Game methodsFor: 'accessing' stamp: 'Tc 12/4/2016 21:26'!
swaworld: aWorld
	world := aWorld.! !

!SWA014Game methodsFor: 'accessing' stamp: 'MV 1/20/2017 18:11'!
upgradeBar
	^ upgradeBar.! !

!SWA014Game methodsFor: 'accessing' stamp: 'MV 1/20/2017 18:11'!
upgradeBar: aBar
	upgradeBar := aBar.! !

!SWA014Game methodsFor: 'accessing' stamp: 'MV 1/13/2017 14:03'!
upgradeDictionary
	^ upgradeDictionary.! !

!SWA014Game methodsFor: 'accessing' stamp: 'MV 1/13/2017 14:03'!
upgradeDictionary: aDictionary
	upgradeDictionary := aDictionary.! !

!SWA014Game methodsFor: 'accessing' stamp: 'MV 1/24/2017 11:34'!
upgradesNewToBlob
	^ upgradesNewToBlob.! !

!SWA014Game methodsFor: 'accessing' stamp: 'MV 1/24/2017 11:34'!
upgradesNewToBlob: aList
	upgradesNewToBlob := aList.! !

Morph subclass: #SWA014UpgradeBar
	instanceVariableNames: 'upgradeCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014UpgradeBar methodsFor: 'accessing' stamp: 'MV 1/20/2017 18:50'!
add: anUpgrade
	self addMorph: anUpgrade.
	anUpgrade center: (self center x)@(self position y + 50 + (self upgradeCount * 100)).
	anUpgrade extent: 75@75.
	self upgradeCount: self upgradeCount + 1.! !

!SWA014UpgradeBar methodsFor: 'initialization' stamp: 'MV 1/20/2017 18:16'!
initialize
	super initialize.
	self 
		extent: 50@500;
		color: Color transparent;
		upgradeCount: 0;
		yourself.! !

!SWA014UpgradeBar methodsFor: 'accessing' stamp: 'MV 1/20/2017 17:38'!
upgradeCount
	^ upgradeCount.! !

!SWA014UpgradeBar methodsFor: 'accessing' stamp: 'MV 1/20/2017 17:38'!
upgradeCount: aNumber
	upgradeCount := aNumber.! !

Morph subclass: #SWA014World
	instanceVariableNames: 'worldSize listOfEnemies listOfFood blob game realCenter image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'world content' stamp: 'MV 1/13/2017 16:54'!
blob
	^blob.! !

!SWA014World methodsFor: 'world content' stamp: 'MV 1/13/2017 16:54'!
blob: aBlob
	blob := aBlob.! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:31'!
checkForBorderCollisions
	self listOfLivingThings do: [:enemy | 
		self checkOnRightSide: enemy.
		self checkOnLeftSide: enemy.
		self checkOnTopSide: enemy.
		self checkOnBottomSide: enemy].! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:31'!
checkOnBottomSide: anEnemy
	anEnemy bounds bottom > self bounds bottom ifTrue: [
			anEnemy isBlob ifTrue: [
				self realCenter: (self realCenter x)@(anEnemy bounds bottom - self radius).
				self refreshCenter]. 
			anEnemy realCenter: (anEnemy realCenter x)@(self worldSize - anEnemy radius).
			anEnemy refreshCenter]! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:29'!
checkOnLeftSide: anEnemy
	anEnemy bounds left < self bounds left ifTrue: [
			anEnemy isBlob ifTrue: [
				self realCenter: (anEnemy bounds left + self radius)@(self realCenter y).
				self refreshCenter]. 
			anEnemy realCenter: (anEnemy radius)@(anEnemy realCenter y).
			anEnemy refreshCenter].! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:27'!
checkOnRightSide: anEnemy
	anEnemy bounds right > self bounds right ifTrue:	[
			anEnemy isBlob ifTrue: [
				self realCenter: (anEnemy bounds right - self radius)@(self realCenter y).
				self refreshCenter]. 
			anEnemy realCenter: (self worldSize - anEnemy radius)@(anEnemy realCenter y).
			anEnemy refreshCenter].! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:30'!
checkOnTopSide: anEnemy
	anEnemy bounds top < self bounds top ifTrue: [
			anEnemy isBlob ifTrue: [
				self realCenter: (self realCenter x)@(anEnemy bounds top + self radius).
				self refreshCenter]. 
			anEnemy realCenter: (anEnemy realCenter x)@(anEnemy radius).
			anEnemy refreshCenter].! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 19:29'!
image
	^ image.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 19:29'!
image: anImage
	image := anImage.! !

!SWA014World methodsFor: 'initialization' stamp: 'MV 1/27/2017 11:57'!
initialize
	super initialize.
		
	self 
		image: ( ImageMorph new image: (Form fromFileNamed: 'Chrysanthemum.jpg'));"Be sure, that the picture is in the resource folder with that name"
		addMorph: self image;
		listOfEnemies: Set new;
		listOfFood: Set new;
		blob: nil;
		worldSize: 3000;
		extent: self worldSize asPoint;	
		center: 0 asPoint;
		realCenter: 0.0 asPoint;
		yourself.
		! !

!SWA014World methodsFor: 'world content' stamp: 'L.K. 1/13/2017 14:52'!
listOfEnemies
	^ listOfEnemies.! !

!SWA014World methodsFor: 'world content' stamp: 'L.K. 1/13/2017 14:53'!
listOfEnemies: aList
	listOfEnemies := aList.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:39'!
listOfFood
	^ listOfFood.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/2/2017 22:57'!
listOfFood: aList
	listOfFood := aList.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 21:15'!
listOfLivingThings
	|listOfLivingThings|
	listOfLivingThings := self listOfEnemies copy.
	listOfLivingThings add: self blob.
	^listOfLivingThings.! !

!SWA014World methodsFor: 'body transformation' stamp: 'Tc 1/13/2017 14:34'!
radius
	^worldSize / 2.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter
	^realCenter.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter: aPoint
	realCenter := aPoint.! !

!SWA014World methodsFor: 'movement' stamp: 'MV 1/7/2017 15:57'!
refreshCenter
	self center: self realCenter.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'MV 12/22/2016 11:00'!
step
	self 
		checkForBorderCollisions;
		"refreshCenter;"
		yourself.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'L.K. 1/13/2017 14:52'!
stepTime
	^100.! !

!SWA014World methodsFor: 'body transformation' stamp: 'L.K. 1/13/2017 14:53'!
worldSize
	^worldSize.! !

!SWA014World methodsFor: 'body transformation' stamp: 'L.K. 1/13/2017 14:53'!
worldSize: anObject
	worldSize := anObject.! !

ImageMorph subclass: #SWA014Menu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Menu class methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:32'!
open
	^SWA014Menu new openInWorld.! !

!SWA014Menu methodsFor: 'initialization' stamp: 'MV 1/3/2017 01:25'!
initialize 
	super initialize.
	
	self 
		image: (Form fromFileNamed: 'Chrysanthemum.jpg'); "Be sure, that the picture is in the resource folder with the correct name"
		addMorph:  SWA014StartButton new;
		addMorph: SWA014EndButton new;
		yourself.! !

ImageMorph subclass: #SWA014Upgrade
	instanceVariableNames: 'upgradeOwner coolDownMorph cooling cooldown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Upgrade commentStamp: 'MV 1/21/2017 14:48' prior: 0!
To add a new Upgrade change: Game->initializeDictionary, Game->handleKeystroke, and right now Game->showEvolveOptions. !

SWA014Upgrade subclass: #SWA014DrainUpgrade
	instanceVariableNames: 'drainTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014DrainUpgrade methodsFor: 'starting up' stamp: 'MV 1/21/2017 15:14'!
activateUpgrade
	self drainTarget: self upgradeOwner nearestEnemy.
	self drainTarget borderColor: Color lavender.
	self startStepping.
	self futureDo: #stopStepping at: 4000 args: #().
	self drainTarget futureDo: #borderColor: at: 4000 args: (Array with: Color black).! !

!SWA014DrainUpgrade methodsFor: 'accessing' stamp: 'MV 1/20/2017 19:50'!
drainTarget
	^ drainTarget! !

!SWA014DrainUpgrade methodsFor: 'accessing' stamp: 'MV 1/20/2017 19:50'!
drainTarget: anObject
	drainTarget := anObject! !

!SWA014DrainUpgrade methodsFor: 'initialization' stamp: 'MV 1/21/2017 14:35'!
initialize
	super initialize.
	self 
		image: (Form fromFileNamed: 'DrainUpgrade.png');
		stopStepping;
		yourself.! !

!SWA014DrainUpgrade methodsFor: 'override' stamp: 'MV 1/21/2017 14:38'!
step
	self drainTarget = nil ifFalse: [
		self drainTarget bodysize: (self drainTarget bodysize - 3).
		self upgradeOwner bodysize: (self upgradeOwner bodysize + 3)].! !

!SWA014DrainUpgrade methodsFor: 'override' stamp: 'MV 1/21/2017 14:41'!
stepTime
	^ 400.
	! !

SWA014Upgrade subclass: #SWA014NullUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014NullUpgrade methodsFor: 'starting up' stamp: 'MV 1/7/2017 15:16'!
activateUpgrade
 "This class should do nothing"! !

SWA014Upgrade subclass: #SWA014ShockwaveUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014ShockwaveUpgrade methodsFor: 'starting up' stamp: 'MV 1/27/2017 12:50'!
activateUpgrade
	self upgradeOwner swaworld listOfLivingThings do: [:enemy|
		((self upgradeOwner distanceTo: enemy realCenter) < (self upgradeOwner radius + 200) squared) ifTrue: [
			enemy realCenter: enemy realCenter + (200 * (self upgradeOwner vectorToPoint: enemy realCenter)).
			enemy refreshCenter]] without: self upgradeOwner.! !

SWA014Upgrade subclass: #SWA014SpeedboostUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014SpeedboostUpgrade methodsFor: 'starting up' stamp: 'MV 1/21/2017 15:15'!
activateUpgrade
	self upgradeOwner 
		speed: self upgradeOwner speed + 11;
		futureDo: #speed: at: 1000 args: (Array with: (self upgradeOwner speed - 11));
		yourself.! !

!SWA014SpeedboostUpgrade methodsFor: 'initialization' stamp: 'MV 1/20/2017 19:32'!
initialize
	super initialize.
	self image: (Form fromFileNamed: 'SpeedBoostUpgrade.png').! !

SWA014Upgrade subclass: #SWA014TrapUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014TrapUpgrade methodsFor: 'starting up' stamp: 'MV 1/21/2017 13:37'!
activateUpgrade
 	self spawnTrap.
			! !

!SWA014TrapUpgrade methodsFor: 'initialization' stamp: 'MV 1/20/2017 19:31'!
initialize
	super initialize.
	self image: (Form fromFileNamed: 'TrapUpgrade.png').! !

!SWA014TrapUpgrade methodsFor: 'world manipulation' stamp: 'MV 1/13/2017 01:08'!
spawnTrap
	|aTrap|
	aTrap := SWA014Trap new.
	aTrap swaworld: self upgradeOwner swaworld.
	aTrap center: self upgradeOwner center - (self upgradeOwner direction * self upgradeOwner bodysize).
	self upgradeOwner swaworld addMorph: aTrap.
! !

!SWA014Upgrade methodsFor: 'starting up' stamp: 'MV 1/22/2017 02:49'!
activateIfNotCooling
	self cooling ifFalse: [
		self
			activateUpgrade;
			cooling: true;
			futureDo: #cooling: at: (self cooldown) args: (Array with: false);
			yourself].
		self coolDownMorph show.
		self coolDownMorph futureDo: #hide at: (self cooldown) args: #().! !

!SWA014Upgrade methodsFor: 'starting up' stamp: 'MV 1/21/2017 14:49'!
activateUpgrade
	"The different Upgrades should overwrite this. This method gets called, when the player wants to use an Upgrade."
	"To add a new Upgrade change: Game->initializeDictionary, Game->handleKeystroke, and right now Game->showEvolveOptions."
	self SubclassResponsibility.
	! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/22/2017 02:45'!
coolDownMorph
	^ coolDownMorph.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/22/2017 02:45'!
coolDownMorph: aMorph
	coolDownMorph := aMorph.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/13/2017 01:50'!
cooldown
	^ cooldown.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/13/2017 01:50'!
cooldown: aTime
	cooldown := aTime.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/13/2017 01:41'!
cooling
	^ cooling.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 1/13/2017 01:41'!
cooling: aBoolean
	cooling := aBoolean.! !

!SWA014Upgrade methodsFor: 'initialization' stamp: 'MV 1/22/2017 02:46'!
initialize
	super initialize.
	self coolDownMorph: ImageMorph new.
		
	self 
		cooling: false;
		cooldown: 10000;
		addMorph:self coolDownMorph;
		yourself.
		
	self coolDownMorph image: (Form fromFileNamed: 'Cooldown.png').
	self coolDownMorph hide.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:58'!
upgradeOwner
	^upgradeOwner.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'MV 12/22/2016 14:58'!
upgradeOwner: aLivingThing
	upgradeOwner := aLivingThing.! !

SimpleButtonMorph subclass: #SWA014ChooseButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014ChooseButton methodsFor: 'initialization' stamp: 'MV 1/13/2017 13:53'!
initialize 
	super initialize.

	self 
		label: 'Choose!!';
		color: Color red;
		yourself.! !

!SWA014ChooseButton methodsFor: 'event handling' stamp: 'MV 1/24/2017 13:03'!
mouseDown: event
	self owner getChosen.! !

SimpleButtonMorph subclass: #SWA014EndButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EndButton methodsFor: 'initialization' stamp: 'Tc 12/31/2016 14:48'!
initialize 
	super initialize.

	self 
		label: 'End Game';
		color: Color yellow;
		center: (World width /2)@((13/25) * World height); "The position is set full out of our preferences"
		yourself.! !

!SWA014EndButton methodsFor: 'event handling' stamp: 'Tc 1/13/2017 14:33'!
mouseDown: event
	self owner delete.! !

SimpleButtonMorph subclass: #SWA014StartButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014StartButton methodsFor: 'initialization' stamp: 'MV 1/2/2017 23:18'!
initialize 
	super initialize.

	self 
		label: 'Start Game';
		color: Color blue;
		center: (World width /2)@((12/25) * World height);
		yourself.! !

!SWA014StartButton methodsFor: 'event handling' stamp: 'MV 12/16/2016 11:33'!
mouseDown: evt
	SWA014Game open.! !

StringMorph subclass: #SWA014Highscore
	instanceVariableNames: 'value world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 12:03'!
highscoreValue
	^value.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 12:03'!
highscoreValue: aValue
	value := aValue.! !

!SWA014Highscore methodsFor: 'initialization' stamp: 'Tc 1/13/2017 15:33'!
initialize 
	super initialize.
	
	self
		highscoreValue: 0;
		acceptValue: 0;
		color: Color red;
		width: 500;
		height: 500;
		yourself.! !

!SWA014Highscore methodsFor: 'updating' stamp: 'Tc 1/13/2017 15:42'!
setNewHighscore
	|highscoreValueAsString|
	
	((self highscoreValue + 60) < self swaworld blob bodysize ) ifTrue: [self highscoreValue:  (self swaworld blob bodysize - 60) asInteger].
	highscoreValueAsString := self highscoreValue asString.
	self fontName: 'BitstreamVeraSans' size: 60.
	! !

!SWA014Highscore methodsFor: 'stepping' stamp: 'Tc 1/13/2017 15:42'!
step
	self setNewHighscore.
	self acceptValue: value.! !

!SWA014Highscore methodsFor: 'stepping' stamp: 'Tc 1/13/2017 11:58'!
stepTime
	^1.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:54'!
swaworld
	^world
! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:55'!
swaworld: aWorld
	world := aWorld! !
